#!/bin/bash

readonly DEV_RELEASE=1 # 1 for development builds - 0 for production builds
source /root/customize_root_image-constants.inc


set -e -u

# configure timezone and locales
ln -sf /usr/share/zoneinfo/UTC /etc/localtime
for locale in ${LOCALES} ; do sed -i "s/#${locale}/${locale}/" /etc/locale.gen ; done ;
locale-gen

# configure sudo
chmod 750 /etc/sudoers.d
chmod 440 /etc/sudoers.d/g_wheel

# configure pacman
sed -i "s|#Server|Server|" /etc/pacman.d/mirrorlist
if   [[ "${enable_offline_install}" == 'true' ]]
then cat /etc/pacman-offline.conf                                  > /etc/pacman-online.conf
     for repo in ${REPOS}
     do echo -e "\n[${repo}]\nInclude = /etc/pacman.d/mirrorlist" >> /etc/pacman-online.conf
     done
     cp /etc/pacman-offline.conf                                     /etc/pacman.conf
else cp /usr/share/pacman/defaults/pacman.conf.${arch}               /etc/pacman.conf
     rm /etc/pacman-*.conf
fi

# KLUDGE begin # TODO: https://labs.parabola.nu/issues/1527
echo "Server = https://parabola.isacdaavid.info:8081/\$repo/os/\$arch" > /etc/pacman.d/mirrorlist
# KLUDGE end

# configure services
if   [[ "${iso_init}" == 'systemd' ]]
then # delete files that are specific to other init systems
     rm ${SYSTEMD_DELETE_FILES}

     # enable services
     systemctl enable ${SYSTEMD_SERVICES}
elif [[ "${iso_init}" == 'openrc' ]]
then # delete files that are specific to other init systems
     rm ${OPENRC_DELETE_FILES}

     # enable services
     for service in ${OPENRC_SERVICES} ; do rc-update add ${service} default ; done ;

     # create the dbus user and group if it does not exist
     if [[ "$(grep 'dbus' /etc/group )" = "" ]] ; then groupadd -g 81 dbus ; fi ;
     if [[ "$(grep 'dbus' /etc/passwd)" = "" ]] ; then useradd -r -s /sbin/nologin -g 81 -u 81 dbus ; fi ;
else echo "invalid \$iso_init for services '${iso_init}'"
     exit 1
fi

# configure root user
usermod -s ${DEFAULT_SHELL} root 2> /dev/null

# configure CLI login session
sed -i "s|_EDITION_TITLE_|${iso_title}|"                                    /etc/motd
sed -i "s|_NETWORK_MOTD_MSG_|${NETWORK_MOTD_MSG}| ; s|^>>>>\(.*\)|    \1|g" /etc/motd
if   [[ "${iso_gui}" == 'cli' ]]
then cp ${ROOT_SKEL_FILES} /root/
     sed -i "s|_DESKTOP_SESSION_||" /root/.bash_profile

else # configure GUI login session and live user
     [[ -n "$(id ${LIVE_USER} 2> /dev/null)" ]] && userdel -r ${LIVE_USER} 2> /dev/null
     useradd -m -p "" -g users -G "${USER_GROUPS}" -s ${DEFAULT_SHELL} ${LIVE_USER}
     if   [[ "${iso_init}" == 'systemd' ]]
     then sed -i "s|--autologin root|--autologin ${LIVE_USER}|" /etc/systemd/system/getty@tty1.service.d/autologin.conf
     fi

     # configure desktop environment
     sed -i "s|_EDITION_TITLE_|${WELCOME_TITLE}|" /home/${LIVE_USER}/.config/autostart/autostart.sh
     sed -i "s|--question|--info|"                /home/${LIVE_USER}/.config/autostart/autostart.sh
     sed -i "s|--cancel-label=.*|\&|"             /home/${LIVE_USER}/.config/autostart/autostart.sh

     if   [[ "${iso_gui}" == 'lxde' ]]
     then rm -f /etc/xdg/autostart/octopi-notifier.desktop 2> /dev/null
          sed -i "s|_DESKTOP_SESSION_|LXDE|" /home/${LIVE_USER}/.bash_profile
          sed -i "s|_DESKTOP_SESSION_|LXDE|" /home/${LIVE_USER}/.dmrc
     elif [[ "${iso_gui}" == 'mate' ]]
     then sed -i "s|_DESKTOP_SESSION_|mate|" /home/${LIVE_USER}/.bash_profile
          sed -i "s|_DESKTOP_SESSION_|mate|" /home/${LIVE_USER}/.dmrc
     else echo "invalid \$iso_gui for _DESKTOP_SESSION_ '${iso_gui}'"
          exit 1
     fi
fi

# development builds - set DEV_RELEASE=0 for production builds
(($DEV_RELEASE)) && source /root/customize_root_image-dev.sh 2> /dev/null
